org.apache.http.impl.conn

## Class AbstractClientConnAdapter

- java.lang.Object
- - org.apache.http.impl.conn.AbstractClientConnAdapter

- All Implemented Interfaces:
    Closeable, AutoCloseable, ConnectionReleaseTrigger, HttpRoutedConnection, ManagedClientConnection, ManagedHttpClientConnection, org.apache.http.HttpClientConnection, org.apache.http.HttpConnection, org.apache.http.HttpInetConnection, org.apache.http.protocol.HttpContext
  Direct Known Subclasses:
    AbstractPooledConnAdapter

  Deprecated.
  (4.2) do not use

      @Deprecated
      public abstract class AbstractClientConnAdapter
      extends Object
      implements ManagedClientConnection, org.apache.http.protocol.HttpContext

  Abstract adapter from `operated` to `managed` client connections. Read and write methods are delegated to the wrapped connection. Operations affecting the connection state have to be implemented by derived classes. Operations for querying the connection state are delegated to the wrapped connection if there is one, or return a default value if there is none.

  This adapter tracks the checkpoints for reusable communication states, as indicated by `markReusable` and queried by `isMarkedReusable`. All send and receive operations will automatically clear the mark.

  Connection release calls are delegated to the connection manager, if there is one. `abortConnection` will clear the reusability mark first. The connection manager is expected to tolerate multiple calls to the release method.

  Since:
    4.0

- - ### Field Summary

    - ### Fields inherited from interface org.apache.http.protocol.HttpContext

      `RESERVED_PREFIX`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractClientConnAdapter(ClientConnectionManager mgr, OperatedClientConnection conn)` Deprecated. Creates a new connection adapter.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `abortConnection()` Deprecated. Releases the connection without the option of keep-alive.
    `protected void` | `assertNotAborted()` Deprecated. (4.1) use `assertValid(OperatedClientConnection)`
    `protected void` | `assertValid(OperatedClientConnection wrappedConn)` Deprecated. Asserts that there is a valid wrapped connection to delegate to.
    `void` | `bind(Socket socket)` Deprecated. Binds this connection to the given socket.
    `protected void` | `detach()` Deprecated. Detaches this adapter from the wrapped connection.
    `void` | `flush()` Deprecated.
    `Object` | `getAttribute(String id)` Deprecated.
    `InetAddress` | `getLocalAddress()` Deprecated.
    `int` | `getLocalPort()` Deprecated.
    `protected ClientConnectionManager` | `getManager()` Deprecated.
    `org.apache.http.HttpConnectionMetrics` | `getMetrics()` Deprecated.
    `InetAddress` | `getRemoteAddress()` Deprecated.
    `int` | `getRemotePort()` Deprecated.
    `Socket` | `getSocket()` Deprecated. Returns the underlying socket.
    `int` | `getSocketTimeout()` Deprecated.
    `SSLSession` | `getSSLSession()` Deprecated. Obtains the SSL session of the underlying connection, if any.
    `protected OperatedClientConnection` | `getWrappedConnection()` Deprecated.
    `boolean` | `isMarkedReusable()` Deprecated. Indicates whether this connection is in a reusable communication state.
    `boolean` | `isOpen()` Deprecated.
    `protected boolean` | `isReleased()` Deprecated.
    `boolean` | `isResponseAvailable(int timeout)` Deprecated.
    `boolean` | `isSecure()` Deprecated. Indicates whether this connection is secure.
    `boolean` | `isStale()` Deprecated.
    `void` | `markReusable()` Deprecated. Marks this connection as being in a reusable communication state.
    `void` | `receiveResponseEntity(org.apache.http.HttpResponse response)` Deprecated.
    `org.apache.http.HttpResponse` | `receiveResponseHeader()` Deprecated.
    `void` | `releaseConnection()` Deprecated. Releases the connection with the option of keep-alive.
    `Object` | `removeAttribute(String id)` Deprecated.
    `void` | `sendRequestEntity(org.apache.http.HttpEntityEnclosingRequest request)` Deprecated.
    `void` | `sendRequestHeader(org.apache.http.HttpRequest request)` Deprecated.
    `void` | `setAttribute(String id, Object obj)` Deprecated.
    `void` | `setIdleDuration(long duration, TimeUnit unit)` Deprecated. Sets the duration that this connection can remain idle before it is reused.
    `void` | `setSocketTimeout(int timeout)` Deprecated.
    `void` | `unmarkReusable()` Deprecated. Marks this connection as not being in a reusable state.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.http.conn.ManagedClientConnection

      `getRoute, getState, layerProtocol, open, setState, tunnelProxy, tunnelTarget`

    - ### Methods inherited from interface org.apache.http.conn.ManagedHttpClientConnection

      `getId`

    - ### Methods inherited from interface org.apache.http.HttpConnection

      `close, shutdown`

- - ### Constructor Detail

    - #### AbstractClientConnAdapter

          protected AbstractClientConnAdapter(ClientConnectionManager mgr,
                                   OperatedClientConnection conn)

      Deprecated.
      Creates a new connection adapter. The adapter is initially not `marked` as reusable.
      Parameters:
        `mgr` - the connection manager, or `null`
        `conn` - the connection to wrap, or `null`

  - ### Method Detail

    - #### detach

          protected void detach()

      Deprecated.
      Detaches this adapter from the wrapped connection. This adapter becomes useless.

    - #### getWrappedConnection

          protected OperatedClientConnection getWrappedConnection()

      Deprecated.

    - #### getManager

          protected ClientConnectionManager getManager()

      Deprecated.

    - #### assertNotAborted

          @Deprecated
          protected final void assertNotAborted()
                                         throws InterruptedIOException

      Deprecated. (4.1) use `assertValid(OperatedClientConnection)`
      Throws:
        `InterruptedIOException`

    - #### isReleased

          protected boolean isReleased()

      Deprecated.
      Returns:
        value of released flag
      Since:
        4.1

    - #### assertValid

          protected final void assertValid(OperatedClientConnection wrappedConn)
                                    throws ConnectionShutdownException

      Deprecated.
      Asserts that there is a valid wrapped connection to delegate to.
      Throws:
        `ConnectionShutdownException` - if there is no wrapped connection or connection has been aborted

    - #### isOpen

          public boolean isOpen()

      Deprecated.
      Specified by:
        `isOpen` in interface `org.apache.http.HttpConnection`

    - #### isStale

          public boolean isStale()

      Deprecated.
      Specified by:
        `isStale` in interface `org.apache.http.HttpConnection`

    - #### setSocketTimeout

          public void setSocketTimeout(int timeout)

      Deprecated.
      Specified by:
        `setSocketTimeout` in interface `org.apache.http.HttpConnection`

    - #### getSocketTimeout

          public int getSocketTimeout()

      Deprecated.
      Specified by:
        `getSocketTimeout` in interface `org.apache.http.HttpConnection`

    - #### getMetrics

          public org.apache.http.HttpConnectionMetrics getMetrics()

      Deprecated.
      Specified by:
        `getMetrics` in interface `org.apache.http.HttpConnection`

    - #### flush

          public void flush()
                     throws IOException

      Deprecated.
      Specified by:
        `flush` in interface `org.apache.http.HttpClientConnection`
      Throws:
        `IOException`

    - #### isResponseAvailable

          public boolean isResponseAvailable(int timeout)
                                      throws IOException

      Deprecated.
      Specified by:
        `isResponseAvailable` in interface `org.apache.http.HttpClientConnection`
      Throws:
        `IOException`

    - #### receiveResponseEntity

          public void receiveResponseEntity(org.apache.http.HttpResponse response)
                                     throws org.apache.http.HttpException,
                                            IOException

      Deprecated.
      Specified by:
        `receiveResponseEntity` in interface `org.apache.http.HttpClientConnection`
      Throws:
        `org.apache.http.HttpException`
        `IOException`

    - #### receiveResponseHeader

          public org.apache.http.HttpResponse receiveResponseHeader()
                                                             throws org.apache.http.HttpException,
                                                                    IOException

      Deprecated.
      Specified by:
        `receiveResponseHeader` in interface `org.apache.http.HttpClientConnection`
      Throws:
        `org.apache.http.HttpException`
        `IOException`

    - #### sendRequestEntity

          public void sendRequestEntity(org.apache.http.HttpEntityEnclosingRequest request)
                                 throws org.apache.http.HttpException,
                                        IOException

      Deprecated.
      Specified by:
        `sendRequestEntity` in interface `org.apache.http.HttpClientConnection`
      Throws:
        `org.apache.http.HttpException`
        `IOException`

    - #### sendRequestHeader

          public void sendRequestHeader(org.apache.http.HttpRequest request)
                                 throws org.apache.http.HttpException,
                                        IOException

      Deprecated.
      Specified by:
        `sendRequestHeader` in interface `org.apache.http.HttpClientConnection`
      Throws:
        `org.apache.http.HttpException`
        `IOException`

    - #### getLocalAddress

          public InetAddress getLocalAddress()

      Deprecated.
      Specified by:
        `getLocalAddress` in interface `org.apache.http.HttpInetConnection`

    - #### getLocalPort

          public int getLocalPort()

      Deprecated.
      Specified by:
        `getLocalPort` in interface `org.apache.http.HttpInetConnection`

    - #### getRemoteAddress

          public InetAddress getRemoteAddress()

      Deprecated.
      Specified by:
        `getRemoteAddress` in interface `org.apache.http.HttpInetConnection`

    - #### getRemotePort

          public int getRemotePort()

      Deprecated.
      Specified by:
        `getRemotePort` in interface `org.apache.http.HttpInetConnection`

    - #### isSecure

          public boolean isSecure()

      Deprecated.
      Description copied from interface: `ManagedClientConnection`
      Indicates whether this connection is secure. The return value is well-defined only while the connection is open. It may change even while the connection is open.
      Specified by:
        `isSecure` in interface `HttpRoutedConnection`
      Specified by:
        `isSecure` in interface `ManagedClientConnection`
      Returns:
        `true` if this connection is secure, `false` otherwise

    - #### bind

          public void bind(Socket socket)
                    throws IOException

      Deprecated.
      Description copied from interface: `ManagedHttpClientConnection`
      Binds this connection to the given socket. The connection is considered open if it is bound and the underlying socket is connection to a remote host.
      Specified by:
        `bind` in interface `ManagedHttpClientConnection`
      Parameters:
        `socket` - the socket to bind the connection to.
      Throws:
        `IOException`

    - #### getSocket

          public Socket getSocket()

      Deprecated.
      Description copied from interface: `ManagedHttpClientConnection`
      Returns the underlying socket.
      Specified by:
        `getSocket` in interface `ManagedHttpClientConnection`

    - #### getSSLSession

          public SSLSession getSSLSession()

      Deprecated.
      Description copied from interface: `ManagedClientConnection`
      Obtains the SSL session of the underlying connection, if any. If this connection is open, and the underlying socket is an `SSLSocket`, the SSL session of that socket is obtained. This is a potentially blocking operation.

      Note: Whether the underlying socket is an SSL socket can not necessarily be determined via `ManagedClientConnection.isSecure()`. Plain sockets may be considered secure, for example if they are connected to a known host in the same network segment. On the other hand, SSL sockets may be considered insecure, for example depending on the chosen cipher suite.

      Specified by:
        `getSSLSession` in interface `HttpRoutedConnection`
      Specified by:
        `getSSLSession` in interface `ManagedClientConnection`
      Specified by:
        `getSSLSession` in interface `ManagedHttpClientConnection`
      Returns:
        the underlying SSL session if available, `null` otherwise

    - #### markReusable

          public void markReusable()

      Deprecated.
      Description copied from interface: `ManagedClientConnection`
      Marks this connection as being in a reusable communication state. The checkpoints for reuseable communication states (in the absence of pipelining) are before sending a request and after receiving the response in its entirety. The connection will automatically clear the checkpoint when used for communication. A call to this method indicates that the next checkpoint has been reached.

      A reusable communication state is necessary but not sufficient for the connection to be reused. A `route` mismatch, the connection being closed, or other circumstances might prevent reuse.

      Specified by:
        `markReusable` in interface `ManagedClientConnection`

    - #### unmarkReusable

          public void unmarkReusable()

      Deprecated.
      Description copied from interface: `ManagedClientConnection`
      Marks this connection as not being in a reusable state. This can be used immediately before releasing this connection to prevent its reuse. Reasons for preventing reuse include error conditions and the evaluation of a `reuse strategy`.

      Note: It is not necessary to call here before writing to or reading from this connection. Communication attempts will automatically unmark the state as non-reusable. It can then be switched back using `markReusable`.

      Specified by:
        `unmarkReusable` in interface `ManagedClientConnection`

    - #### isMarkedReusable

          public boolean isMarkedReusable()

      Deprecated.
      Description copied from interface: `ManagedClientConnection`
      Indicates whether this connection is in a reusable communication state. See `markReusable` and `unmarkReusable` for details.
      Specified by:
        `isMarkedReusable` in interface `ManagedClientConnection`
      Returns:
        `true` if this connection is marked as being in a reusable communication state, `false` otherwise

    - #### setIdleDuration

          public void setIdleDuration(long duration,
                             TimeUnit unit)

      Deprecated.
      Description copied from interface: `ManagedClientConnection`
      Sets the duration that this connection can remain idle before it is reused. The connection should not be used again if this time elapses. The idle duration must be reset after each request sent over this connection. The elapsed time starts counting when the connection is released, which is typically after the headers (and any response body, if present) is fully consumed.
      Specified by:
        `setIdleDuration` in interface `ManagedClientConnection`

    - #### releaseConnection

          public void releaseConnection()

      Deprecated.
      Description copied from interface: `ConnectionReleaseTrigger`
      Releases the connection with the option of keep-alive. This is a "graceful" release and may cause IO operations for consuming the remainder of a response entity. Use `abortConnection` for a hard release. The connection may be reused as specified by the duration.
      Specified by:
        `releaseConnection` in interface `ConnectionReleaseTrigger`

    - #### abortConnection

          public void abortConnection()

      Deprecated.
      Description copied from interface: `ConnectionReleaseTrigger`
      Releases the connection without the option of keep-alive. This is a "hard" release that implies a shutdown of the connection. Use `ConnectionReleaseTrigger.releaseConnection()` for a graceful release.
      Specified by:
        `abortConnection` in interface `ConnectionReleaseTrigger`

    - #### getAttribute

          public Object getAttribute(String id)

      Deprecated.
      Specified by:
        `getAttribute` in interface `org.apache.http.protocol.HttpContext`

    - #### removeAttribute

          public Object removeAttribute(String id)

      Deprecated.
      Specified by:
        `removeAttribute` in interface `org.apache.http.protocol.HttpContext`

    - #### setAttribute

          public void setAttribute(String id,
                          Object obj)

      Deprecated.
      Specified by:
        `setAttribute` in interface `org.apache.http.protocol.HttpContext`

Copyright © 1999–2022 The Apache Software Foundation. All rights reserved.